<template>
  <div
    data-component-group="auth-form"
    data-component="join-account"
  >
    <JoinAccountNotification
      v-if="hasSentRequest"
      :business-name="selectedBusiness.name"
    />
    <Form
      v-else
      :title="$t('views.join_account.title')"
      :second-title="$t('views.join_account.second_title')"
      :subtitle="emailDomain !== '' ?
        $t('views.join_account.subtitle').replace('{0}', '<strong>@'+emailDomain+'</strong>')
        : ''"
    >
      <ul
        v-if="businesses.length > 0"
        class="business-list"
      >
        <li
          v-for="business in businesses"
          :key="business.name"
          class="business"
        >
          <span class="business-name">
            {{ business.name }}
          </span>
          <v-btn
            class="trigger select-business"
            :loading="isLoading && business.id === selectedBusiness.id"
            @click="selectBusiness(business)"
          >
            <v-icon>
              add
            </v-icon>
            {{ 'Join' }}
          </v-btn>
        </li>
      </ul>

      <div class="note">
        <p>
          <i18n
            path="views.join_account.note"
            tag="label"
            for="action"
          >
            <v-btn
              flat
              depressed
              :ripple="false"
              @click="onReenterAddress"
            >
              {{ $t('views.join_account.action') }}
            </v-btn>
          </i18n>
        </p>
      </div>
    </Form>
  </div>
</template>

<script>
  import colors from 'vuetify/es5/util/colors';
  import Form from '../Form';
  import JoinAccountNotification from '../../notifications/auth/JoinAccount';
  import router from '../../../router';
  import { isUndef } from '../../../utils';

  export default {
    components: {
      Form,
      JoinAccountNotification
    },
    data: () => ({
      businesses: [],
      selectedBusiness: {
        name: ''
      },
      emailDomain: '',
      hasSentRequest: false,
      isSubmitted: false,
      isLoading: false,
      colors
    }),
    created() {
      this.$watch(() => {
        const user = this.$store.getters['auth/user'];
        const hasErrors = this.$store.getters['alerts/error'].length > 0;

        this.watchUser(user);

        if (this.isSubmitted && hasErrors) {
          this.isLoading = false;
          this.isSubmitted = false;
        }

        if (!this.hasSentRequest && !isUndef(user.business_id)) {
          this.hasSentRequest = true;
        }
      });
    },
    methods: {
      selectBusiness(business) {
        const { token } = this.$route.params;
        this.selectedBusiness = business;

        this.isSubmitted = true;
        this.isLoading = true;
        return this.$store.dispatch('auth/joinAccount', { business, token });
      },
      onReenterAddress() {
        router.replace({ name: 'login' });
      },
      watchUser(user) {
        const { emailDomain, businesses } = user;

        if (this.emailDomain !== emailDomain) {
          this.emailDomain = emailDomain;
          this.businesses = businesses;
        }
      }
    },
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="auth-form"] {
    &[data-component="join-account"] {
      width: 100%;

      .business-list {
        list-style-type: none;
        padding: 0;
        margin: 0 0 30px 0;
        display: flex;
        justify-content: space-between;
        align-items: center;
        flex-wrap: wrap;

        .business {
          width: 100%;
          display: flex;
          justify-content: space-between;
          align-items: center;
          padding: 10px $spacing-sm
          margin: 0 0 10px 0;
          border-radius: 4px;
          border: 1px solid $colors.grey.lighten-2;
          background-color: $colors.grey.lighten-5;

          &:last-child {
            margin: 0;
          }

          .business-name {
            font-size: 16px;
            font-weight: bold;
          }

          .trigger.select-business {
            padding: 6px 40px;
            border-radius: 6px;
            color: $colors.shades.white;
            background-color: $colors.primary;

            .v-icon {
              margin: 0 6px 0 0;
            }
          }
        }
      }

      .note {
        p {
          font-size: 12px;
        }

        .v-btn {
          display: inline-block;
          padding: 0;
          margin: 0;
          font-size: 12px;
          text-transform: none;
          vertical-align: top;
          text-decoration: none;
          height: auto;

          &:before {
            background-color: transparent !important;
          }
        }
      }
    }
  }
</style>
